#target indesign

$.localize = true;
$.locale = 'ru' //'en' for english

var lng = {
	noVersion: 		localize({en:'Can\'t run script in current version InDesign!', ru:'Невозможно запустить скрипт в этой версии InDesign!'}),
	noDoc: 			localize({en:'No documents are open!', ru:'Нет открытых документов!'}),
	allDone: 		localize({en:'All done!', ru:'Все готово!'}),
	findInDoc: 		localize({en:'Text object not selected!\nProcess whole document?', ru:'Текстовый объект не выбран!\nОбработать весь документ?'}),
	findPStyle: 	localize({en:'Find paragraph style:', ru:'Стиль абзаца для поиска:'}),
	splitPara: 		localize({en:'split pararaphs', ru:'разделять параграфы'}),
	setTstyle: 		localize({en:'Apply table style', ru:'Применить стиль таблицы:'}),
	setPTstyle: 	localize({en:'Table paragraph style', ru:'Стиль абзаца для таблицы'}),
}

var scriptVersion = '0.9b';
var scriptLabel = 'olegbutrin.scripts.tabborder';

// initial settings define. no reasons to edit it here
var settings = {
	findPara: 0,
	splitPara: false,
	applyTable: 0,
	applyPara: 0
}


Array.prototype.getIndexByField = function (field, value) {
	
	for (var i = 0; i < this.length; i++) {
		if (this[i][field] == value) {
			return i;
		};
	};

	return -1;

}


function getFullName (item) {
	
	if (!item.hasOwnProperty('name')) {
		return String(item);
	}

	try {
		var chk = item.parent;
		var chk = item.name;
	} catch (error) {
		return null;
	}

	if (item.parent.constructor.name == 'Document') {
		return item.name;
	} else {
		var res = [];
		do {
			res.push(item.name);
			item = item.parent;
		} while (item.constructor.name != 'Document');
		return res.reverse().join(' : ')
	}

}


function getItemById (collection, id) {

	for (var i = 0; i < collection.length; i++) {
		if (collection[i].id == id) {
			return collection[i];
		};
	};

	return null;

}


function getColectionList (collection) {

	var result = [];

	for (var i = 0; i < collection.length; i++) {
		var name =  getFullName(collection[i]);
		if (name) {
			result.push({name: name, id:collection[i].id});
		};
	};

	return result;

}

function getCollectionNames (collectionList) {

	var result = [];

	for (var i = 0; i < collectionList.length; i++) {
		result.push(collectionList[i].name);
	};

	return result;

}


function findAllText (doc, findObject, findPara) {

	if (app.hasOwnProperty('findTextPreferences')) {

		app.findTextPreferences = NothingEnum.NOTHING;
		app.changeTextPreferences = NothingEnum.NOTHING;

		app.findTextPreferences.appliedParagraphStyle = findPara;
		var res = findObject.findText(true);

		app.findTextPreferences = NothingEnum.NOTHING;
		app.changeTextPreferences = NothingEnum.NOTHING;

	} else {

		app.findPreferences = null;
		app.changePreferences = null;

		app.findPreferences.appliedParagraphStyle = findPara;
		var res = findObject.search();

		app.findPreferences = null;
		app.changePreferences = null;

	};

	return res;

}


function splitPara (text) {

	var res = [];
	for (var i = 0; i < text.paragraphs.length; i++) {
		res.push(text.paragraphs[i]);
	};

	return res.reverse();

}


function saveSettings (doc, settings) {

	doc.insertLabel(scriptLabel, settings.toSource());

}


function loadSettings (doc) {

	var prev = doc.extractLabel(scriptLabel);

	if (prev) {
		return eval(prev);
	};

	return settings;

}


function applySettings (doc, findObject, settings) {

	if (doc.hasOwnProperty('allParagraphStyles')) {
		var findPara = getItemById(doc.allParagraphStyles, settings.findPara);
		var applyPara = getItemById(doc.allParagraphStyles, settings.applyPara);
	} else {
		var findPara = getItemById(doc.paragraphStyles, settings.findPara);
		var applyPara = getItemById(doc.paragraphStyles, settings.applyPara);
	};

	if (doc.hasOwnProperty('allTableStyles')) {
		var applyTable = getItemById(doc.allTableStyles, settings.applyTable);
	} else {
		var applyTable = getItemById(doc.tableStyles, settings.applyTable);
	};
	
	var allTexts = findAllText(doc, findObject, findPara)

	var rawText = [];

	for (var i = 0; i < allTexts.length; i++) {
		if (allTexts[i].parent.constructor.name != 'Cell' && allTexts[i].tables.length == 0 && allTexts[i].paragraphs[0].tables.length == 0) {
			if (settings.splitPara) {
				rawText = rawText.concat(splitPara(allTexts[i]))
			} else {
				rawText.push(allTexts[i]);
			};
		};
	};

	rawText.sort( function (a,b) {return a.index - b.index} );
	rawText.reverse();

	var ranges = [];

	for (var i = 0; i < rawText.length; i++) {
		var text = rawText[i];
		if (text.characters[text.characters.length - 1].contents == '\u000D') {
			var tr = text.characters.itemByRange(0, text.characters.length - 2).getElements()[0];
		} else {
			var tr = text.characters.itemByRange(0, text.characters.length - 1).getElements()[0];
		}
		ranges.push(tr);
	}

	for (var i = 0; i < ranges.length; i++) {
		var index = ranges[i].index;
		var story = ranges[i].parentStory;
		var tbl = ranges[i].convertToTable('\u0001', '\u0001', 1);
		tbl.insertLabel(scriptLabel, 'true');
		tbl.appliedTableStyle = applyTable;
		if (tbl.storyOffset.constructor.name == 'InsertionPoint') {
			tbl.storyOffset.appliedParagraphStyle == applyPara;
		} else {
			story.characters[index].appliedParagraphStyle = applyPara;
		}
	};

	return true;

}


function main () {

	if (!app.hasOwnProperty('scriptPreferences') || app.scriptPreferences.version < 4) {
		alert(lng.noVersion);
		return false;
	};

	try {
		var doc = app.activeDocument;
	} catch (error) {
		alert(lng.noDoc);
		return false;
	}

	try {
		var findObject = app.selection[0].parentStory;
	} catch (error) {
		var res = Window.confirm(lng.findInDoc, true);
		if (res) {
			var findObject = doc;
		} else {
			return false;
		};
	}

	if (doc.hasOwnProperty('allParagraphStyles')) {
		var paraList = getColectionList(doc.allParagraphStyles);
	} else {
		var paraList = getColectionList(doc.paragraphStyles);
	}

	if (doc.hasOwnProperty('allTableStyles')) {
		var tablList = getColectionList(doc.allTableStyles);
	} else {
		var tablList = getColectionList(doc.tableStyles);
	};

	var settings = loadSettings(doc);

	var dialog = app.dialogs.add({name:'TabBorder ' + scriptVersion});

	with (dialog.dialogColumns.add().borderPanels.add().dialogColumns.add()) {

		with (dialogRows.add().dialogColumns.add().borderPanels.add().dialogColumns.add()) {

			dialogRows.add().staticTexts.add({staticLabel: lng.findPStyle});
			var userFindPara = dialogRows.add().dropdowns.add({
				stringList: getCollectionNames(paraList), 
				selectedIndex: paraList.getIndexByField('id', settings.findPara),
			});
			var userSplitPara = dialogRows.add().checkboxControls.add({
				staticLabel: lng.splitPara, 
				checkedState:settings.splitPara
			});
			dialogRows.add().staticTexts.add({staticLabel: lng.setTstyle});
			var userApplyTabl = dialogRows.add().dropdowns.add({
				stringList: getCollectionNames(tablList), 
				selectedIndex: tablList.getIndexByField('id', settings.applyTable),
			});
			dialogRows.add().staticTexts.add({staticLabel: lng.setPTstyle});
			var userApplyPara = dialogRows.add().dropdowns.add({
				stringList: getCollectionNames(paraList), 
				selectedIndex: paraList.getIndexByField('id', settings.applyPara),
			});
		}

		dialogRows.add().staticTexts.add({staticLabel:'Oleg Butrin (wp.me/p0Xz) © 2014'})

	}

	if (!dialog.show()) {
		return false;
	}

	settings.findPara = paraList[userFindPara.selectedIndex].id;
	settings.splitPara = userSplitPara.checkedState;
	settings.applyTable = tablList[userApplyTabl.selectedIndex].id;
	settings.applyPara = paraList[userApplyPara.selectedIndex].id;

	saveSettings(doc, settings);

	var res = applySettings(doc, findObject, settings);

	return res;

}

if (main()) {
	alert(lng.allDone);
}